CON

  _clkmode = xtal1 + pll8x
  _xinfreq = 10_000_000
  _stack    = 100
  
  spiDO  = 8
  spiClk = 9     
  spiDI  = 10
  spiCS  = 11
  
  xStart = 1
  yMin = 3
  SpeakerPin = 7
  TabAMax = 2
  rows = 20

  SOH      =     1                                         ' Packet Start
  EOT      =     4                                         ' End of Transmission
  ACK      =     6                                         ' Positive Acknowledgement
  NAK      =     21                                        ' Negative Acknowledgement
  CAN      =     24                                        ' Cancel
  PAD      =     26                                        ' Padding at the end of the file

  CR = 13
  LF = 10
  RX_Buffer=     12
  
  ScreenWidth           = 40
  ScreenHeight          = 25
  ScreenHalfWidth       = 20
  ScreenHalfHeight      = 12


  black   =  $02        
  White   =  $06        
  Yel     =  $8D                 
  Cyan    =  $3C
  Red     =  $5C
  Green   =  $BC
  Purple  =  $1C        
  Blue    =  $FC

  Gray    =  $03
  ltWhite =  $07
  ltYel   =  $8E
  ltCyan  =  $3E
  ltRed   =  $5D
  ltGreen =  $CE
  ltPurple  =  $1E
  ltBlue  =  $FE

  cntMin     = 400


VAR
  long ioControl[2]
  long ptr
  long gp
  long chr
  long x_pos, y_pos
  long index
  byte buffer[14]
  byte FileName[14]
  byte CurrTabIndex
  'byte yMax
  byte num[2]
  byte KeyVal
  byte strbuff[255]
  byte ReadByte
  byte yMax[4]
  byte TabMax

  byte Packet
  byte XRECV
  byte CRC
  BYTE Rx_Data[RX_Buffer] 
  byte xbuf[128]
  byte ProgressPos
  byte ProgressXsize
  byte ProgressYsize
  
    
OBJ

  txt : "char_mode_10"
  fsrw : "fsrwFemto"
'  snd : "NS_sound_drv_052_11khz_16bit"
'  key : "comboKeyboard"
'  Ser : "256_FullDuplexSerial"
  
PUB start | i,counter

  txt.start(3)
  'txt.PrintStrAt(0,5,Yel,Black,String("Abort"),0)
  fsrw.start(@ioControl)                                  ' Start I2C/SPI driver
  if \fsrw.mount(spiDO,spiClk,spiDI,spiCS) < 0            ' Attempt to mount SD card
    txt.PrintStrAt(0,5,Yel,Black,String("No Sd card Found"),0)
    abort
  y_pos:=yMin
  x_pos:=xStart
  'TabIndex:=0
  CurrTabIndex:=0
  drawboarder
  
  Files
  y_pos:=yMin
  x_pos:=xStart
  'key.start(14)
  
  'snd.start(SpeakerPin)
  
  repeat
        'ReadByte:=ser.rxtime(100)
        gp := NES_Read_Gamepad
        'keyVal:=key.key
        if gp & GP_SELECT | (keyVal == $0D)
          if \fsrw.popen(@Buffer,"r")                           
            txt.PrintStrAt(xStart,10,Yel,Black,string("File Not Found"),0)
            abort                             
          fsrw.bootSDCard                                         

        if (gp & GP_UP) | (keyVal == $C2)
          if y_pos <> yMin
              x_pos:=xStart + CurrTabIndex * 13
              repeat until (txt.CharAt(x_pos,y_pos) == 32 or txt.CharAt(x_pos,y_pos) == $18) 
                txt.SwapColors(x_pos,y_pos)
                x_pos++                    
              x_pos:=xStart + CurrTabIndex * 13
              y_pos--
              Index:=0
               
              repeat until (txt.CharAt(x_pos,y_pos) == 32 or txt.CharAt(x_pos,y_pos) == $18) 
                Buffer[index] := txt.CharAt(x_pos,y_pos)
                txt.SwapColors(x_pos,y_pos)
                x_pos++
                index++                    
              pause(100)
              Buffer[Index+1]:=0
               
        if (gp & GP_Down) | (keyVal == $C3)
          if y_pos <> yMax[CurrTabIndex]
              x_pos:=xStart + CurrTabIndex * 13
              repeat until (txt.CharAt(x_pos,y_pos) == 32 or txt.CharAt(x_pos,y_pos) == $18) 
                txt.SwapColors(x_pos,y_pos)
                x_pos++                    
              x_pos:=xStart + CurrTabIndex * 13
              y_pos++
               
              Index:=0
              repeat until (txt.CharAt(x_pos,y_pos) == 32 or txt.CharAt(x_pos,y_pos) == $18) 
                Buffer[index] := txt.CharAt(x_pos,y_pos)
                txt.SwapColors(x_pos,y_pos)
                x_pos++
                index++
              pause(100)
              Buffer[Index+1]:=0

        if (gp & GP_Left) '| (keyVal == $C3)
          if CurrTabIndex <> 0
              x_pos:=xStart + CurrTabIndex * 13
              repeat until (txt.CharAt(x_pos,y_pos) == 32 or txt.CharAt(x_pos,y_pos) == $18) 
                txt.SwapColors(x_pos,y_pos)
                x_pos++
              CurrTabIndex--                      
              x_pos:=xStart + CurrTabIndex * 13
               
              Index:=0
              repeat until (txt.CharAt(x_pos,y_pos) == 32 or txt.CharAt(x_pos,y_pos) == $18) 
                Buffer[index] := txt.CharAt(x_pos,y_pos)
                txt.SwapColors(x_pos,y_pos)
                x_pos++
                index++
              pause(100)
              Buffer[Index+1]:=0

        if (gp & GP_Right) '| (keyVal == $C3)
          if CurrTabIndex <> TabMax and y_pos =< yMax[CurrTabIndex+1]
              x_pos:=xStart + CurrTabIndex * 13
              repeat until (txt.CharAt(x_pos,y_pos) == 32 or txt.CharAt(x_pos,y_pos) == $18)
                txt.SwapColors(x_pos,y_pos)
                x_pos++
              CurrTabIndex++                      
              x_pos:=xStart + CurrTabIndex * 13
               
              Index:=0
              repeat until (txt.CharAt(x_pos,y_pos) == 32 or txt.CharAt(x_pos,y_pos) == $18)
                Buffer[index] := txt.CharAt(x_pos,y_pos)
                txt.SwapColors(x_pos,y_pos)
                x_pos++
                index++
              pause(100)
              Buffer[Index+1]:=0
{              
        if keyVal == "d" or ReadByte == "d"
          txt.ClearScreen
          y_pos:=yMin
          x_pos:=xStart
          drawboarder
  
          Files
          y_pos:=yMin
          x_pos:=xStart

        if ReadByte == "t" or keyVal == "t"
          UPLOAD
          
          txt.ClearScreen
          y_pos:=yMin
          x_pos:=xStart
          drawboarder
  
          Files
          y_pos:=yMin
          x_pos:=xStart
          
        
        if keyVal == "u"
          UpdateProgressBar
 }       
                 
PUB Files | a, t ,TabIndex, xTab, Idx
    a:=1
    TabIndex:=0
    Idx:=0
    'ser.str(string("dir|"))
    if \fsrw.mount(spiDO,spiClk,spiDI,spiCS) < 0            ' Attempt to mount SD card
      txt.PrintStrAt(xStart,5,Yel,Black,String("Abort"),0)
      abort
    fsrw.opendir
    repeat while fsrw.nextfile(@ptr) == 0
      'ser.str(@ptr)
      'ser.tx(126)
      xTab:= 1 + TabIndex * 13    
      t:=StrRight(@ptr,3)
      if strcomp(t,string("BIN"))
         txt.PrintStrAt(xTab,y_pos,Yel,Black,@ptr,a)
         y_pos++
         a++
         Idx++
      if Idx => 60
        quit
      if y_pos == Rows+3
         yMax[TabIndex]:=Rows+2
         if TabIndex <> TabAMax
           TabIndex++
           TabMax++
         y_pos:=yMin
    index:=0
    
    yMax[TabIndex]:=y_pos -1
    x_pos:=xStart
    y_pos:=yMin

    repeat until (txt.CharAt(x_pos,y_pos) == 32 or txt.CharAt(x_pos,y_pos) == $18)
      Buffer[index] := txt.CharAt(x_pos,y_pos)
      x_pos++
      index++
    Buffer[Index+1]:=0

PUB PAUSE(Duration) | clkCycles
{{
   Causes a pause for the duration in mS
   Smallest value is 2 at clkfreq = 5Mhz, higher frequencies may use 1
   Largest value is around 50 seconds at 80Mhz.
     BS2.Pause(1000)   ' 1 second pause
}}

   clkCycles := Duration * (clkfreq / 1_000) -2300 #> cntMin    ' duration * clk cycles for ms
                                                                                                                                ' - inst. time, min cntMin
   waitcnt( clkCycles + cnt )                                           ' wait until clk gets there

PUB StrRight(str,len) | i,l,z

  l:=strSize(str)
  z:=0
  repeat i from l-len to l
    strbuff[z] := byte[@ptr][i]
    z++
  return @strbuff

PUB DrawBoarder

    txt.PrintStrAt(0,0,White,Black,string(14,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,15),0)
    repeat Index from 1 to 23
      txt.PrintStrAt(0,Index,White,Black,string($13,"                                      ",$18),0)  
    txt.PrintStrAt(0,24,White,Black,string($0b,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,8),0)
    txt.PrintStrAt(8,1,ltBlue,Black,string("Select Program to load"),0)  



{
PUB UPLOAD | TCNT , temp, retry, mode
  'txt.ClearScreen
  DrawProgressBar(string("File Copying"))
  'drawboxCenter(13, 3, String(255,cyan,"File Copying"))
  return
  ser.str(String("Type File Name"))                        ' Tell sender we are ready to receive file

  GetFileName
  'ser.str(@Rx_Data)
  PACKET := 1                                              ' Transfer not yet started, Set Packet Number to first 
  RETRY  := 0                                              '                           Clear Retry count
  MODE   := 0                                              '                           Set Mode to zero
  
  REPEAT 80                                                ' 40 seconds max time to wait for sender to send the file
    ser.tx(NAK)                                             ' send NAK to sender to inform them we are ready to receive file
    XRECV := ser.rxtime (500)                               ' wait here for character or time-out

    IF (XRECV == SOH)                                      ' If character received is packet start
      MODE := 1                                            '   Set file transfer mode to state 1
      QUIT                                                 '   exit this repeat loop
  'ser.str(string("Got Here"))
  DrawProgressBar(string("File Copying"))
  fsrw.popen(@RX_Data, "w")
                                 ' open file for write, if exists, then over write the file   
  
  REPEAT WHILE MODE == 1                                   ' While in file transfer state
    CRC := 0                                               ' clear CRC for later calculation 
    XRECV := ser.rx                                         ' get packet number

    IF (XRECV < PACKET - 1) OR (XRECV > PACKET)            ' if packet number is in error
      MODE := 0                                            '   Set to state zero
      QUIT                                                 '   exit this repeat loop
    ELSE
      PACKET := XRECV                                      ' next Packet Number
      
    XRECV := ser.rx                                         ' 1's complement Packet Number   
    TCNT := 0                                              ' set for start of receive buffer
    REPEAT 128                                             ' Get 128 Bytes from Sender
      XBUF[TCNT] := ser.rx                                  '  get character from sender in put in file transfer buffer
      CRC += XBUF[TCNT++]                                  '  update CRC and incriment file transfer buffer
    
    XRECV := ser.rx                                         ' get CRC from sender
    IF (XRECV <> CRC)                                      ' If CRC fail
      IF (RETRY < 10)                                      '  and retrys are less then 10
        ser.tx(21)    'nac                                     '    Tell sender we got a bad packet 
        RETRY++                                            '    incriment re-try count 
        REPEAT                                             '    Check for New Packet 
          XRECV := ser.rx                                   '    get character from sender
          IF (XRECV == SOH)                                '    check character for packet start
            QUIT                                           '    exit this repeat loop
            
      ELSE                                                 ' Too many retrys
          MODE := 0                                        '   set tranfer mode to fail
          QUIT                                             '   exit this repeat loop
          
    ELSE                                                   ' Packet looks OK, lets wirte it to the SD Card
      ser.tx(ACK)                                           '   Send ACK to sender
      UpdateProgressBar
      fsrw.pwrite(@XBUF, 128)                           '       first packet twice???, flag is used to filter and discard
      PACKET++                                           '       the first xmodem packet.
      
      REPEAT                                               ' Check were we are in the file transfer process
        XRECV := ser.rx
        IF (XRECV == EOT)                                  ' End of transmission ?
          ser.tx(ACK)                                       '   send ACK
          waitcnt(clkfreq/10 + cnt)                        '   wait 100mS
          ser.tx (ACK)                                      '   send ACK again
          MODE := 2                                        '   Set mode to completed successfully
          QUIT                                             '   exit this repeat loop
     
        IF (XRECV == CAN)                                  ' Sender Cancelled transmission?
          MODE := 0                                        '   Transfer aborted or incomplete
          QUIT                                             '   exit this repeat loop

        IF (XRECV == SOH)                                  ' Next packet in the file   
          QUIT

  ser.str(String(13,10))                                         ' Send CR & LF to sender
     
  IF (MODE == 2)                                           ' Notify sender of status of file transfer
    ser.str (String("--- Transfer completed succesfully.",13,10)) '   Upload was a success
  ELSE
    ser.str (String("--- Transfer aborted or incomplete.",13,10)) '   Failure in file transfer

  fsrw.pclose                                             ' Close data file & exit          


PUB GetFileName | Rx, Index1

  ser.str(String("Input File Name: ",10))
  
  Index1 := 0
    
  Repeat
    Rx := ser.rx
    'ser.tx(Rx)
      
    if Rx > CR
      if Index1 =< RX_Buffer
        Rx_Data[Index1++] := Rx
      else
        Index := 0  
     
    if Rx == CR
      Rx_Data[Index1++] := 0                                ' zero terminate the string array
      quit
  


Pub DrawProgressBar(Title) | w,h,i
  DrawBoxCenter(13,2,Title)
  w := ScreenHalfWidth - 13 / 2 + 1 
  h := 3 / 2
  txt.PrintStrAt(w, ScreenHalfHeight - h+1, Black, Blue,RepeatChar(8,ProgressPos),0)

'  ProgressPos++
'  if ProgressPos > 12
'    ProgressPos :=0

Pub UpdateProgressBar | w,h
  w := ScreenHalfWidth - 13 / 2 + 1 
  h := 3 / 2
  txt.PrintStrAt(w, ScreenHalfHeight - h+1, Black, Black,Spaces(12),0)
  txt.PrintStrAt(w, ScreenHalfHeight - h+1, Black, Blue,RepeatChar(8,ProgressPos),0)

  ProgressPos++
  if ProgressPos > 12
    ProgressPos :=0
  
PUB DrawBoxCenter(xSize, ySize, Title) | w,h
        w := xSize / 2
        h := ySize / 2
        DrawBox(ScreenHalfWidth - w, ScreenHalfHeight - h, xSize, ySize, Title) 

PUB DrawBox(xPos, yPos, xSize, ySize, Title) | i, p
  p := Spaces(xSize-1)
  repeat i from yPos+1 to yPos + ySize-1
    txt.PrintStrAt(xPos+1, i, White,Black,p,0)

  txt.PrintStrAt(xPos, yPos, White, Black,string(14),0)
  txt.PrintStrAt(xPos+xSize, yPos, White, Black,string(15),0)
  
  repeat i from xPos+1 to xPos+xSize-1
    txt.PrintStrAt(i,yPos, White, Black, string(4),0)
    txt.PrintStrAt(i,yPos+ySize, White, Black, string(5),0)

  repeat i from yPos+1 to yPos+ySize-1
    txt.PrintStrAt(xPos,i, White, Black, string($13),0)  
    txt.PrintStrAt(xPos+xSize,i, White, Black, string($18),0)
  
  txt.PrintStrAt(xPos, yPos+ySize, White, Black,string($0b),0)
  txt.PrintStrAt(xPos+xSize, yPos+ySize, White, Black,string(8),0)
       
  if StrSize(Title) > 0
    txt.PrintStrAt(xPos+1, yPos, White, Black,Title,0)

PUB Spaces(cnt1) | i
  repeat i from 0 to cnt1-1
    strbuff[i] := " "
  strbuff[i] := 0  
  return @strbuff

PUB RepeatChar(aChar, Cnt1) | i  
  bytefill(@strbuff,aChar,Cnt1)
  'repeat i from 0 to cnt1
  '  strbuff[i] := aChar
  strbuff[Cnt1+1] := 0  
  return @strbuff


Pub DrawPallete | i, c, y
  c := $0A
  repeat y from 0 to 4
    repeat i from 0 to 15      
      MyColor.byte[3] := c + i * 16 + y
      txt.PrintStrAt(i+1,y+1, White, Black,@MyColor,0)
}
CON
' //////////////////////////////////////////////////////////////////
' NES Game Paddle Read
' //////////////////////////////////////////////////////////////////       
' reads both gamepads in parallel encodes 8-bits for each in format
' right game pad #1 [15..8] : left game pad #0 [7..0]

    GP_RIGHT  = %00000001
    GP_LEFT   = %00000010
    GP_DOWN   = %00000100
    GP_UP     = %00001000
    GP_START  = %00010000
    GP_SELECT = %00100000
    GP_B      = %01000000
    GP_A      = %10000000

PUB NES_Read_Gamepad : nes_bits        |  i

' set I/O ports to proper direction
' P3 = JOY_CLK      (4)
' P4 = JOY_SH/LDn   (5) 
' P5 = JOY_DATAOUT0 (6)
' P6 = JOY_DATAOUT1 (7)
' NES Bit Encoding

' step 1: set I/Os
DIRA [3] := 1 ' output
DIRA [4] := 1 ' output
DIRA [5] := 0 ' input
DIRA [6] := 0 ' input

' step 2: set clock and latch to 0
OUTA [3] := 0 ' JOY_CLK = 0
OUTA [4] := 0 ' JOY_SH/LDn = 0
'Delay(1)

' step 3: set latch to 1
OUTA [4] := 1 ' JOY_SH/LDn = 1
'Delay(1)

' step 4: set latch to 0
OUTA [4] := 0 ' JOY_SH/LDn = 0

' step 5: read first bit of each game pad

' data is now ready to shift out
' first bit is ready 
nes_bits := 0

' left controller
nes_bits := INA[5] | (INA[6] << 8)

' step 7: read next 7 bits
repeat i from 0 to 6
 OUTA [3] := 1 ' JOY_CLK = 1
 'Delay(1)             
 OUTA [3] := 0 ' JOY_CLK = 0
 nes_bits := (nes_bits << 1)
 nes_bits := nes_bits | INA[5] | (INA[6] << 8)

 'Delay(1)             
' invert bits to make positive logic
nes_bits := (!nes_bits & $FFFF)

' //////////////////////////////////////////////////////////////////
' End NES Game Paddle Read
' //////////////////////////////////////////////////////////////////  
      

Dat

MyColor byte 249,2,255,7,8,0

 